#include "mbed.h"
#include "gap_common.h"
#include "cmsis.h"
#include "crypto_aead.h"
#include "api.h"
#include "uartp.h"

#define MAX_BYTES 100
#define CMDBUF_LEN 72
static uint8_t cmdbuf[CMDBUF_LEN];

#define CRYPTO_BUSY GPIO_A21

Serial device(USBTX, USBRX);

uint8_t npub[CRYPTO_NPUBBYTES];
uint8_t nsec[CRYPTO_NSECBYTES];
uint8_t k[CRYPTO_KEYBYTES];
uint8_t ad[MAX_BYTES];
uint8_t m[MAX_BYTES];
uint8_t c[MAX_BYTES];
unsigned long long int adlen = 0;
unsigned long long int mlen = 0;
unsigned long long int clen = 0;
int res = 0;

void setup();
void loop();

DigitalOut crypto_pin(CRYPTO_BUSY);

extern "C" {

void uart_wbyte(uint8_t x) {
    device.putc((uint8_t) (x));
}

uint8_t uart_rbyte() {
    int r;
    do {
        r = device.getc();
    } while (r == -1);
    return (uint8_t) (0xff & r);
}

}

void my_assert(bool b) {
    if (b)
        return;
    for(;;)
        wait_ms(0.1);
}

void setup() {
    device.baud(115200);
    PORT_SetPinMux(PORTA, 35, uPORT_MuxGPIO);
    crypto_pin = 1;
    wait_ms(100);
    memset(npub, 0, CRYPTO_NPUBBYTES);
    memset(nsec, 0, CRYPTO_NSECBYTES);
    memset(k, 0, CRYPTO_KEYBYTES);
    memset(ad, 0, MAX_BYTES);
    memset(m, 0, MAX_BYTES);
    memset(c, 0, MAX_BYTES);
    device.printf("Hello, World!");
}

void loop() {
    int res;
    uint16_t len = uartp_recv(cmdbuf, CMDBUF_LEN - 1);
    uint8_t action = cmdbuf[0];
    if (len == 0 || len > CMDBUF_LEN - 1)
        while (1) {};

    uint16_t l = len - 1;
    uint16_t rl = 0;
    uint8_t *var = cmdbuf+1;
    switch (action) {
        case 'm': my_assert(l <= MAX_BYTES);        memcpy(m,    var, l); mlen = l; break;
        case 'c': my_assert(l <= MAX_BYTES);        memcpy(c,    var, l); clen = l; break;
        case 'a': my_assert(l <= MAX_BYTES);        memcpy(ad,   var, l); adlen = l; break;
        case 'k': my_assert(l == CRYPTO_KEYBYTES);  memcpy(k,    var, l); break;
        case 'p': my_assert(l == CRYPTO_NPUBBYTES); memcpy(npub, var, l); break;
        case 's': my_assert(l == CRYPTO_NSECBYTES); memcpy(nsec, var, l); break;
        case 'e':
		  __disable_irq();	
			__NOP();
            crypto_pin = 0;
            res = crypto_aead_encrypt(c, &clen, m, mlen, ad, adlen, nsec, npub, k);
            crypto_pin = 1;
			__NOP();
      __enable_irq();			
            break;
        case 'd':
      __disable_irq();
			__NOP();
            crypto_pin = 0;
            res = crypto_aead_decrypt(m, &mlen, nsec, c, clen, ad, adlen, npub, k);
            crypto_pin = 1;
			__NOP();
      __enable_irq();			
            break;
        case'M': var = m;    rl = mlen; break;
        case'C': var = c;    rl = clen; break;
        case'A': var = ad;   rl = adlen; break;
        case'K': var = k;    rl = CRYPTO_KEYBYTES; break;
        case'P': var = npub; rl = CRYPTO_NPUBBYTES; break;
        case'S': var = nsec; rl = CRYPTO_NSECBYTES; break;
        case'R': var = (uint8_t *) &res; rl = sizeof(res); break;
        default:
            my_assert(false);
    }
    cmdbuf[0] = action;
    memcpy(cmdbuf+1, var, rl);
    uartp_send(cmdbuf, rl+1);
}

int main() {
    setup();
    while(1) loop();
}

